#
# spec file for package libv4l (Version 0.6.4)
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#



Name:           libv4l
Summary:        Collection of video4linux support libraries
Version:        0.6.4
Release:        9.1
Group:          System/Libraries
License:        LGPLv2.0+
Url:            http://people.atrpms.net/~hdegoede/
Source0:        http://people.atrpms.net/~hdegoede/%{name}-%{version}.tar.gz
Source2:        baselibs.conf
Patch0:         libv4l-nonvoid_return.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  kernel-headers pkg-config

%define debug_package_requires libv4l1-0 = %{version}-%{release}
%define debug_package_requires libv4l2-0 = %{version}-%{release}
%define debug_package_requires libv4lconvert0 = %{version}-%{release}

%description
libv4l is a collection of libraries which adds a thin abstraction layer
on top of video4linux2 devices. The purpose of this (thin) layer is to
make it easy for application writers to support a wide variety of
devices without having to write separate code for different devices in
the same class. libv4l consists of 3 different libraries:
libv4lconvert, libv4l1 and libv4l2.

libv4lconvert offers functions to convert from any (known) pixelformat
to V4l2_PIX_FMT_BGR24 or V4l2_PIX_FMT_YUV420.

libv4l1 offers the (deprecated) v4l1 API on top of v4l2 devices,
independent of the drivers for those devices supporting v4l1
compatibility (which many v4l2 drivers do not).

libv4l2 offers the v4l2 API on top of v4l2 devices, while adding for
the application transparent libv4lconvert conversion where necessary.

%package -n libv4l1-0
License:        LGPLv2.0+
Summary:        The libv4l1-0 shared lib
Group:          System/Libraries
Requires:       %{name}

%description -n libv4l1-0
This package contains shared lib for packages that
use libv4l1.so.0

%package -n libv4l2-0
License:        LGPLv2.0+
Summary:        The libv4l2-0 shared lib
Group:          System/Libraries
Requires:       %{name}

%description -n libv4l2-0
This package contains shared lib for packages that
use libv4l2.so.0

%package -n libv4lconvert0
License:        LGPLv2.0+
Summary:        The libv4lconvert0 shared lib
Group:          System/Libraries
Requires:       %{name}

%description -n libv4lconvert0
This package contains shared lib for packages that
use libv4lconvert.so.0

%package        devel
License:        LGPLv2.0+
Summary:        The libv4l devel headers
Group:          Development/Libraries/C and C++
Requires:       libv4l1-0 = %{version}
Requires:       libv4l2-0 = %{version}
Requires:       libv4lconvert0 = %{version}

%description    devel
The libv4l-devel package contains libraries and header files for
developing applications that use libv4l.

%prep
%setup -q
%patch0

%build
%{__make} CFLAGS="$RPM_OPT_FLAGS" %{?_smp_mflags}

%install
make PREFIX=%{_prefix} LIBDIR=%{_libdir} DESTDIR=$RPM_BUILD_ROOT install

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post -n libv4l1-0 -p /sbin/ldconfig

%postun -n libv4l1-0 -p /sbin/ldconfig

%post -n libv4l2-0 -p /sbin/ldconfig

%postun -n libv4l2-0 -p /sbin/ldconfig

%post -n libv4lconvert0 -p /sbin/ldconfig

%postun -n libv4lconvert0 -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc ChangeLog COPYING.LIB README TODO
%{_libdir}/%{name}

%files -n libv4l1-0
%defattr(-,root,root,-)
%{_libdir}/libv4l1.so.*

%files -n libv4l2-0
%defattr(-,root,root,-)
%{_libdir}/libv4l2.so.*

%files -n libv4lconvert0
%defattr(-,root,root,-)
%{_libdir}/libv4lconvert.so.*

%files devel
%defattr(-,root,root,-)
%doc README.multi-threading
%{_includedir}/libv4l*.h
%{_libdir}/libv4l*.so
%{_libdir}/pkgconfig/*.pc

%changelog
* Thu Jun 10 2010 wittemar@googlemail.com
- build libv4l-32bit
* Mon May 17 2010 coolo@novell.com
- remove explicit version requires to non-versioned package from
  shared libraries
- buildrequire pkg-config to fix provides
* Mon Feb 22 2010 ro@suse.de
- buildfix: "control reaches end of non-void function"
* Mon Feb 22 2010 bphilips@novell.com
- Upstream doesn't provide bz2. Change back to gz in URL.
* Mon Feb 22 2010 bphilips@novell.com
- Update to v0.6.4
  - Add more laptop models to the upside down devices table
  - Add error checking to mr97310a decompression
  - Increase mr97310a minimum clockdiv upon 3 consecutive decoding errors
  - Add support for decompressing CPIA1 compressed YUV
  - Speed up autogain algorithm
- Updates from v0.6.3
  - Add more laptop models to the upside down devices table
  - Improved mr97310a decompression
  - Add support for decompressing yuv420 planar JPEG (one component per SOS,
    3 SOS per frame), this is needed for w9968cf based cams
  - Add support for STV0680 raw bayer data
- Updates from v0.6.2
  - Add more laptop models to the upside down devices table
  - Put usb id in controls shm segment name for USB devices, to better
    distuingish between devices plugged into the same port
  - Enable software whitebalance and autogain for mr97310a cameras
  - Improvements / tweaks to software autogain algorithm
* Fri Jan 15 2010 chris@computersalat.de
- cleanup spec
  * shared libs to subpkg
  * added debug_package_requires
  * bzipped source
- rpmlint
  * devel-package-with-non-devel-group
  * summary-not-capitalized
- added baselibs.conf as a source2
  o and updated
* Tue Sep  1 2009 schaeferf.obs@googlemail.com
- Update to v0.6.1
  - Add more laptop models to the upside down devices table
  - Bugfix: fixup 320x240 output for pac7302 cameras
  - Bugfix: fix reqbuf Device or Resource busy error when using v4l2_read()
  - Some applications want to use jpg format if possible, so do not hide
    it from the apps (do not assume it always needs conversion)
  - Change controls shm segment name to include the username, as it is only
    writable by the user (this means libv4l controls are per user) (Gregor Jasny)
  - Add support for decompressing sn9c2028 compressed bayer (Theodore Kilgore)
  - Report V4L2_FMT_FLAG_EMULATED in v4l2_fmtdesc flags for emulated formats
* Thu Aug  6 2009 schaeferf.obs@googlemail.com
- Update to v0.6.0
  - Software whitebalancing, automatic gain, exposure and gamma control for cams which lack this in hardware
  - Fake v4l2 controls to control all these
  - Software flipping controls
  - Recognize disabled controls and replace with fake equivalents where available
  - Add tons of laptop models to the upside down devices table
  - Add support for decompressing ov511 and ov518 "JPEG"
  - Improved pac207 decompression code
  - Support for rgb565 source format
  - Many bug fixes
- Merge spec files from drivers:webcam and openSUSE:Factory <bphilips@suse.de>
* Tue Mar 10 2009 bphilips@suse.de
- Add baselibs.conf to build -32bit packages
- Version bump to 0.5.8
  * Add support for UYVY (for USB Apple iSight) patch by Julien BLACHE
    <jb@jblache.org>
  * Remove v4lconvert_yvyu_to_yuv420 function as its functionality is
    duplicate with v4lconvert_yuyv_to_yuv420
  * Use Requires.private where appropiate in .pc files (patch by Gregor Jasny)
  * Switch to using USB-id's instead of USB product string, as not all devices
    set a unique product string. This fixes the upside down issues with
    genius e-messenger 112 cams
  * Add support for sn9c20x-i420 format patch by Vasily Khoruzhick
    <anarsoul@gmail.com>
* Thu Dec  4 2008 bphilips@suse.de
- Version bump to 0.5.7
  * Fix a nasty (and stupid) bug in the special try_fmt handling for UVC cams
  * Add some more verbose logging of various calls when asking libv4l to log
    calls to a file, to assist in (future) debugging
  libv4l-0.5.6
  * Always do a s_fmt on uvc cams even if this changes nothing, as not doing
    the s_fmt triggers a bug in the uvcvideo driver in kernel <= 2.6.28
    (with certain cams)
  libv4l-0.5.5
  * Avoid the use of try_fmt as much as possible on UVC cams, instead use the
    results of the enum_framesizes ioctl. This is because:
    1) try_fmt actually causes IO with UVC cams making apps which do lot of
    querrying of device capabilities slow (cheese)
    2) some buggy cams don't like getting lots of UVC video probes and crash
    when they do
  libv4l-0.5.4
  * Don't report DQBUF errors when errno is EAGAIN, this fixes flooding the
    screen with errors when applications use non blocking mode
  * Add support for downscaling to make apps which want low resolutions
    (skype, spcaview) happy when used with cams which can only do high
    resolutions (by Lukáš Karas <lukas.karas@centrum.cz>).
  * Add support for converting to YV12 planar (next to the already supported
    YU12 / I420)
  * Implement RGB/BGR24 -> YU/YV12 conversion
  libv4l-0.5.3
  * When conversion requires multiple passes don't alloc the needed temporary
    buffer on the stack, as some apps (ekiga) use so much stack themselves
    this causes us to run out of stack space
  libv4l-0.5.2
  * Add Philips SPC210NC to list of cams with upside down sensor, reported by
    Rieker Flaik
  * Work around some drivers (pwc) not properly reflecting what one gets after a
    s_fmt in their try_fmt answer
  * Check that s_fmt atleast gives us the width, height and pixelformat try_fmt
    promised us, and if not disable conversion
  * Only check width, height and pixelformat when checking if we are doing
    conversion, instead of doing a memcmp, as that are the only things which
    the convert code checks
  * Take into account that the buffers only contain half of the lines when
    field is V4L2_FIELD_ALTERNATE
  libv4l-0.5.1
  * Add support for software cropping from 352x288 -> 320x240 / 176x144 ->
    160x120, so that apps which will only work with vga resolutions like
    320x240 (Skype!) will work with cams/drivers which do not support cropping
    CIF resolutions to VGA resolutions in hardware. This makes all 2.6.27 gspca
    supported cams, except for the pac7302 which only does 640x480 (and skype
    wants 320x240), work with skype
  * The v4lconvert_convert function was becoming a bit of a mess, so split the
    functionailiy into separate v4lconvert_convert_pixfmt, v4lconvert_rotate and
    v4lconvert_crop functions, and make v4lconvert_convert a frontend to
    these
  * Do not link the wrapper libs against libpthread (patch from Gregor Jasny)
  libv4l-0.5.0
  * Add support for enumerating framesizes and frameintervals of emulated
    formats when the driver supports it for the real format
  * Make sure the video device always gets opened RW even if the application
    asks for RO
  * Add Genius E-Messenger 112 (093a:2476) to list of cams which have their
    sensor upside down
  libv4l-0.4.3
  * Add suport for YUYV and YVYU packed pixel formats (Jean-Francois Moine)
  * Prefer compressed pixformats for resolutions > 176x144
  libv4l-0.4.2
  * The bayer pixel order in gspca's sonixb driver was different from that in
    the sn9c102 driver from the mainline kernel, a recent gspca patch fixes
    this, adjust libv4l to match (and make it work properly with the sn9c102
    driver).
  libv4l-0.4.1
  * When the driver supports read() and we are not converting let the driver
    handle read() instead of emulating it with mmap mode
  * Fix errors and warnings when compiling with ICC (Gregor Jasny)
  * Add support to libv4lconvert for rotating images 90 (for Pixart 7302 cams)
    or 180 (Philips SPC200NC / Philips SPC300NC) degrees
  * Add support for Pixart custom JPEG format
  * Hide non public symbols (Gregor Jasny)
  * Fix and enable x86_64 asm jpeg decompress helper functions (Gregor Jasny)
* Fri Aug 15 2008 bphilips@suse.de
- Initial SuSE package
